package com.sun.org.apache.xpath.internal.functions;

import javax.xml.transform.TransformerException;
import com.sun.org.apache.xml.internal.dtm.DTM;
import com.sun.org.apache.xpath.internal.objects.XString;
import com.sun.org.apache.xpath.internal.objects.XObject;
import com.sun.org.apache.xpath.internal.XPathContext;

public class FuncNamespace extends FunctionDef1Arg
{
    static final long serialVersionUID = -4695674566722321237L;
    
    public FuncNamespace() {
    }
    
    @Override
    public XObject execute(XPathContext xctxt) throws TransformerException {
        int context = this.getArg0AsNode(xctxt);
        if (context != -1) {
            DTM dtm = xctxt.getDTM(context);
            int t = dtm.getNodeType(context);
            String s;
            if (t == 1) {
                s = dtm.getNamespaceURI(context);
            }
            else if (t == 2) {
                s = dtm.getNodeName(context);
                if (s.startsWith("xmlns:") || s.equals("xmlns")) {
                    return XString.EMPTYSTRING;
                }
                s = dtm.getNamespaceURI(context);
            }
            else {
                return XString.EMPTYSTRING;
            }
            return (null == s) ? XString.EMPTYSTRING : new XString(s);
        }
        else {
            return XString.EMPTYSTRING;
        }
    }
}
